<?php
if(!defined("IN_MYBB"))
{
    die("You Cannot Access This File Directly. Please Make Sure IN_MYBB Is Defined.");
} 

$plugins->add_hook('postbit', 'PostNotes_postbit'); 

function PostNotes_info()
{

	return array(
		"name"		=> "PostNotes",
		"description"		=> "Notatki do postow",
		"website"		=> "http://cheqoladowy.blogspot.com",
		"author"		=> "CheQ",
		"authorsite"		=> "http://cheqoladowy.blogspot.com",
		"version"		=> "v0.5",
		"guid" 			=> "",
		"compatibility"	=> "*"
		);
}	
function PostNotes_install()
{
	global $db;
	$db->write_query('CREATE TABLE IF NOT EXISTS `'.TABLE_PREFIX.'postnotes` (note_id int NOT NULL AUTO_INCREMENT , note_owner int NOT NULL , post_id int NOT NULL , note_text varchar(255) charset utf8 collate utf8_unicode_ci , note_type int NOT NULL , PRIMARY KEY(note_id))');
	$postnotes_group = array(
        'gid'    => 'NULL',
        'name'  => 'PostNotes',
        'title'      => 'PostNotes Ustawienia',
        'description'    => 'Ustawienia PostNotes',
        'disporder'    => "1",
        'isdefault'  => "0",
    ); 
	$db->insert_query('settinggroups', $postnotes_group);
	$gid = $db->insert_id(); 
	$postnotes_setting = array(
        'sid'            => 'NULL',
        'name'        => 'PostNotes_onoff',
        'title'            => 'Wlacz/Wylacz Plugin',
        'description'    => 'Czy chcesz wlaczyc plugin?',
        'optionscode'    => 'yesno',
        'value'        => '1',
        'disporder'        => 1,
        'gid'            => intval($gid),
    ); 
	$db->insert_query('settings', $postnotes_setting);
	$tentego_setting = array(
		'name'			=> 'PostNotes_group',
		'title'			=> 'Grupy ',
		'description'	=> 'Grupy które mogą korzystać z notatek (oddzielone przecinkami)',
		'optionscode'	=> 'text', 
		'value'			=> '3,4,6', 
		'disporder'		=> '2',
		'gid'			=> intval($gid)
	);
	$db->insert_query('settings', $tentego_setting);
	$tentego_setting = array(
		'name'			=> 'PostNotes_pw',
		'title'			=> 'Wiadomość ',
		'description'	=> 'Treść wiadomości ({#mod_owner} to moderator który daje notatkę , {#post_id} to post na który notatka została dodane',
		'optionscode'	=> 'textarea', 
		'value'			=> 'Witaj!<br/>{#mod_owner} Dodał nataktę do Twojego postu. Możesz ją zobaczyć <a href = "showthread.php?pid={#post_id}">Klikając tu</a> <br/>Nie odpisuj na tą wiadomość.Została ona wysłana automatycznie. <br/>Ekipa Cs-White.pl',
		'disporder'		=> '3',
		'gid'			=> intval($gid)
	);
	$db->insert_query('settings', $tentego_setting);
	$tentego_setting = array(
		'name'			=> 'PostNotes_sender',
		'title'			=> 'Właściciel Wiadomości ',
		'description'	=> 'Kto ma wysyłać wiadomość ( liczba mniejsza od 1 oznacza że wiadomość wysyła osoba która notatkę dodałą)',
		'optionscode'	=> 'text', 
		'value'			=> '1', 
		'disporder'		=> '4',
		'gid'			=> intval($gid)
	);
	$db->insert_query('settings', $tentego_setting);
	rebuild_settings();
}
function PostNotes_is_installed()
{
	global $db;
	if($db->table_exists("postnotes"))
	{
		return true;
	}
	return false;
}
function PostNotes_uninstall()
{
	global $db;
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN ('PostNotes_onoff')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN ('PostNotes_group')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='PostNotes'");
	$db->query("DROP TABLE `".TABLE_PREFIX."postnotes`");
	rebuild_settings();
}
function PostNotes_postbit(&$post)
{
	global $mybb;
	$notatki = "";
	add_note();
	if($mybb->settings['PostNotes_onoff'] == 1)
	{
		global $db;
		$query=$db->query('SELECT * FROM '.TABLE_PREFIX.'postnotes WHERE post_id ='.$post['pid']);
		while($result=$db->fetch_array($query))
		{
			$css = '';
			switch($result['note_type'])
			{
				case 1:
				{
					$css = "margin:10px;background-color: rgba(0, 255, 0, 0.5);border-radius:5px;";
					break;
				}
				case 2:
				{
					$css = "margin:10px;background-color: rgba(255, 0, 0, 0.5);border-radius:5px;";
					break;
				}
				case 3:
				{
					$css = "margin:10px;background-color: rgba(255, 255, 255, 0.5);border-radius:5px;";
					break;
				}
			}
			$user =  get_user($result['note_owner']);
			$user_group =$db->fetch_array($db->simple_select("usergroups", "*", "gid='$user[usergroup]'"));
			if(can_use_note($mybb->user['uid']))
			{
				$notatki.='<div class = ".note_'.$result['note_type'].'" style = "width:35%;padding:5px;'.$css.'">
				<a href = "member.php?action=profile&uid='.$result['note_owner'].'">'.str_replace('{username}',$user['username'],$user_group['namestyle']).'</a> napisał: <br/>
				'.$result['note_text'].'<br/>
				<form method= "POST">
					<input type="hidden" name="mod_id" readonly="readonly" value="'.$mybb->user['uid'].'"/>
					<input type="hidden" name="remove_note" readonly="readonly" value = "'.$result['note_id'].'"/>
					<input type="submit" value="Usuń notatkę" />
				</form>
				</div>';
			}
			else
			{
				$notatki.='<div class = ".note_'.$result['note_type'].'" style = "width:35%;padding:5px;'.$css.'">
				<a href = "member.php?action=profile&uid='.$result['note_owner'].'">'.str_replace('{username}',$user['username'],$user_group['namestyle']).'</a> napisał: <br/>
				'.$result['note_text'].'<br/></div>';
			}
		}
		if(can_use_note($mybb->user['uid']))
		{
			$post['message'].=$notatki.'<br/>
				<a onclick="javascript:document.getElementById(\'note_post_'.$post['pid'].'\').style.display = \'block\'"><img src = "chq_note.png"/></a>
				<div id = "note_post_'.$post['pid'].'" style = "display:none">
				<form method= "POST">
					<input type="text" name="note_text" value="odpowiedź domyślna" size = "30" />
					<select name="note_type">
						<option>Informacyjna</option>
						<option>Ostrzegawcza</option>
						<option>Zwykła</option>
					</select>
					<input type="hidden" name="mod_id" value="'.$mybb->user['uid'].'" readonly="readonly" />
					<input type="hidden" name="post_id" value="'.$post['pid'].'" readonly="readonly" />
					<input type="submit" value="Dodaj" />
				</form>
				</div>';
		}
		else
		{
			$post['message'].=$notatki;
		}
		
	};
		
} 
function can_use_note($uid)
{
	global $mybb;
	$user = get_user($uid);
	$group = explode(',',$mybb->settings['PostNotes_group']);
	for($i=0; $i<count($group);$i++)
	{
		if($user['usergroup'] == $group[$i])
			return true;
	}
	return false;
}
function add_note()
{
	global $db,$mybb,$path;
	if(isset($_POST['mod_id']) && isset($_POST['post_id']) && isset($_POST['note_text']) && isset($_POST['note_type']) && $mybb->user['uid'] > 0 && can_use_note($mybb->user['uid']))
	{
		$type = 0;
		switch($_POST['note_type'])
		{
			case 'Informacyjna': { $type = 1; break;}
			case 'Ostrzegawcza' : { $type = 2; break;}
			case 'Zwykła' : { $type = 3; break;}
		}
		$type_n = array('Infromacyjną','Ostrzegawczą','Zwykłą');
		$query=$db->query("INSERT INTO `".TABLE_PREFIX."postnotes` (`note_id`, `note_owner`, `post_id`, `note_text`, `note_type`) VALUES (NULL, '".$_POST['mod_id']."', '".$_POST['post_id']."', '".$_POST['note_text']."', '".$type."');");
		$user = get_user($_POST['mod_id']);
		$post = get_post($_POST['post_id']);
		require_once $path . "inc/datahandlers/pm.php";
		$pmhandler = new PMDataHandler();
		$pmhandler->admin_override = true;
		$pm_subject = "Dodano ".$type_n[$type-1]." Notatkę do Twojego Postu!";
		$pm_txt = str_replace('{#mod_owner}',$user ['username'],str_replace('{#post_id}',$post['pid'],$mybb->settings['PostNotes_pw'])); 
		$note_owner_id = $mybb->settings['PostNotes_sender'];
		if($note_owner_id  < 1)
			$note_owner_id  = $user['uid'];
			
		$pm = array(
			"subject" => $pm_subject,
			"message" => $pm_txt,
			"icon" => "-1",
			"toid" => array($post['uid']),
			"fromid" => $note_owner_id,
			"do" => '',
			"pmid" => 1
		);
		$pm['options'] = array(
			"signature" => "1",
			"disablesmilies" => "0",
			"savecopy" => "0",
			"readreceipt" => "0"
		);
	
		$pmhandler->set_data($pm);
				
		if(!$pmhandler->validate_pm())
		{
			// There some problem sending the PM
		}
		else
		{
			$pminfo = $pmhandler->insert_pm();
		}
		
	}
	if(isset($_POST['mod_id']) && isset($_POST['remove_note']) && can_use_note($mybb->user['uid']))
	{	
		$query=$db->query("DELETE FROM `".TABLE_PREFIX."postnotes` where note_id = ".$_POST['remove_note']);
	}
	
	unset($_POST);
}
?>